precision mediump float;

varying vec4 vColour;
varying vec2 vTexCoord;
varying vec4 vNormal;
varying vec4 vPosition;

uniform sampler2D uSampler;
uniform float uExponent;
uniform vec4 uPosLight;
uniform vec4 uPosCamera;

void main(void) {
    vec3 direction = normalize(uPosLight.xyz - vPosition.xyz);
    vec3 normal = normalize(vNormal.xyz + (texture2D(uSampler, vTexCoord.st).xyz - 0.55555) * 0.2);
    vec3 camera = normalize(uPosCamera.xyz - vPosition.xyz);
    vec3 color = vColour.xyz * 0.5 + vColour.xyz * dot(normal, direction) * 0.5 + vec3(1, 1, 1) * 0.4 * pow(max(dot(camera, reflect(-direction, normal)), 0.0), uExponent+1.0);
    gl_FragColor = vec4(color, 1);
}
